Package org.osgi.service.packageadmin

# Interface PackageAdmin

All Known Implementing Classes:
  `PackageAdminImpl`

public interface PackageAdmin
Deprecated.
This service has been replaced by the `org.osgi.framework.wiring` package.
Framework service which allows bundle programmers to inspect the package wiring state of bundles in the Framework as well as other functions related to the class loader network among bundles.

If present, there will only be a single instance of this service registered with the Framework.

Author:
  $Id: 4aad25d2f145d9a2d24825bc481dcc254b74ed51 $
See Also:
  - `ExportedPackage`
  - `RequiredBundle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`BUNDLE_TYPE_FRAGMENT`
Deprecated.
Bundle type indicating the bundle is a fragment bundle.

## Method Summary

Modifier and Type
Method
Description
`Bundle`
`getBundle(Class clazz)`
Deprecated.
Returns the bundle from which the specified class is loaded.
`Bundle[]`
`getBundles(String symbolicName, String versionRange)`
Deprecated.
Returns the bundles with the specified symbolic name whose bundle version is within the specified version range.
`int`
`getBundleType(Bundle bundle)`
Deprecated.
Returns the special type of the specified bundle.
`ExportedPackage`
`getExportedPackage(String name)`
Deprecated.
Gets the exported package for the specified package name.
`ExportedPackage[]`
`getExportedPackages(String name)`
Deprecated.
Gets the exported packages for the specified package name.
`ExportedPackage[]`
`getExportedPackages(Bundle bundle)`
Deprecated.
Gets the exported packages for the specified bundle.
`Bundle[]`
`getFragments(Bundle bundle)`
Deprecated.
Returns an array of attached fragment bundles for the specified bundle.
`Bundle[]`
`getHosts(Bundle bundle)`
Deprecated.
Returns the host bundles to which the specified fragment bundle is attached.
`RequiredBundle[]`
`getRequiredBundles(String symbolicName)`
Deprecated.
Returns an array of required bundles having the specified symbolic name.
`void`
`refreshPackages(Bundle[] bundles)`
Deprecated.
Forces the update (replacement) or removal of packages exported by the specified bundles.
`boolean`
`resolveBundles(Bundle[] bundles)`
Deprecated.
Resolve the specified bundles.

## Field Details

### BUNDLE_TYPE_FRAGMENT

static final int BUNDLE_TYPE_FRAGMENT
Deprecated.
Bundle type indicating the bundle is a fragment bundle.

The value of `BUNDLE_TYPE_FRAGMENT` is 0x00000001.

Since:
  1.2
See Also:
  - Constant Field Values

## Method Details

### getExportedPackages

ExportedPackage[] getExportedPackages(Bundle bundle)
Deprecated.
Gets the exported packages for the specified bundle.

Parameters:
  `bundle` - The bundle whose exported packages are to be returned, or `null` if all exported packages are to be returned. If the specified bundle is the system bundle (that is, the bundle with id zero), this method returns all the packages known to be exported by the system bundle. This will include the package specified by the `org.osgi.framework.system.packages` system property as well as any other package exported by the framework implementation.
Returns:
  An array of exported packages, or `null` if the specified bundle has no exported packages.
Throws:
  `IllegalArgumentException` - If the specified `Bundle` was not created by the same framework instance that registered this `PackageAdmin` service.

### getExportedPackages

ExportedPackage[] getExportedPackages(String name)
Deprecated.
Gets the exported packages for the specified package name.

Parameters:
  `name` - The name of the exported packages to be returned.
Returns:
  An array of the exported packages, or `null` if no exported packages with the specified name exists.
Since:
  1.2

### getExportedPackage

ExportedPackage getExportedPackage(String name)
Deprecated.
Gets the exported package for the specified package name.

If there are multiple exported packages with specified name, the exported package with the highest version will be returned.

Parameters:
  `name` - The name of the exported package to be returned.
Returns:
  The exported package, or `null` if no exported package with the specified name exists.
See Also:
  - `getExportedPackages(String)`

### refreshPackages

void refreshPackages(Bundle[] bundles)
Deprecated.
Forces the update (replacement) or removal of packages exported by the specified bundles.

If no bundles are specified, this method will update or remove any packages exported by any bundles that were previously updated or uninstalled since the last call to this method. The technique by which this is accomplished may vary among different Framework implementations. One permissible implementation is to stop and restart the Framework.

This method returns to the caller immediately and then performs the following steps on a separate thread:

1. Compute a graph of bundles starting with the specified bundles. If no bundles are specified, compute a graph of bundles starting with bundle updated or uninstalled since the last call to this method. Add to the graph any bundle that is wired to a package that is currently exported by a bundle in the graph. The graph is fully constructed when there is no bundle outside the graph that is wired to a bundle in the graph. The graph may contain `UNINSTALLED` bundles that are currently still exporting packages.
2. Each bundle in the graph that is in the `ACTIVE` state will be stopped as described in the `Bundle.stop` method.
3. Each bundle in the graph that is in the `RESOLVED` state is unresolved and thus moved to the `INSTALLED` state. The effect of this step is that bundles in the graph are no longer `RESOLVED`.
4. Each bundle in the graph that is in the `UNINSTALLED` state is removed from the graph and is now completely removed from the Framework.
5. Each bundle in the graph that was in the `ACTIVE` state prior to Step 2 is started as described in the `Bundle.start` method, causing all bundles required for the restart to be resolved. It is possible that, as a result of the previous steps, packages that were previously exported no longer are. Therefore, some bundles may be unresolvable until another bundle offering a compatible package for export has been installed in the Framework.
6. A framework event of type `FrameworkEvent.PACKAGES_REFRESHED` is fired.

For any exceptions that are thrown during any of these steps, a `FrameworkEvent` of type `ERROR` is fired containing the exception. The source bundle for these events should be the specific bundle to which the exception is related. If no specific bundle can be associated with the exception then the System Bundle must be used as the source bundle for the event.

Parameters:
  `bundles` - The bundles whose exported packages are to be updated or removed, or `null` for all bundles updated or uninstalled since the last call to this method.
Throws:
  `SecurityException` - If the caller does not have `AdminPermission[System Bundle,RESOLVE]` and the Java runtime environment supports permissions.
  `IllegalArgumentException` - If the specified `Bundle`s were not created by the same framework instance that registered this `PackageAdmin` service.

### resolveBundles

boolean resolveBundles(Bundle[] bundles)
Deprecated.
Resolve the specified bundles. The Framework must attempt to resolve the specified bundles that are unresolved. Additional bundles that are not included in the specified bundles may be resolved as a result of calling this method. A permissible implementation of this method is to attempt to resolve all unresolved bundles installed in the framework.

If `null` is specified then the Framework will attempt to resolve all unresolved bundles. This method must not cause any bundle to be refreshed, stopped, or started. This method will not return until the operation has completed.

Parameters:
  `bundles` - The bundles to resolve or `null` to resolve all unresolved bundles installed in the Framework.
Returns:
  `true` if all specified bundles are resolved;
Throws:
  `SecurityException` - If the caller does not have `AdminPermission[System Bundle,RESOLVE]` and the Java runtime environment supports permissions.
  `IllegalArgumentException` - If the specified `Bundle`s were not created by the same framework instance that registered this `PackageAdmin` service.
Since:
  1.2

### getRequiredBundles

RequiredBundle[] getRequiredBundles(String symbolicName)
Deprecated.
Returns an array of required bundles having the specified symbolic name.

If `null` is specified, then all required bundles will be returned.

Parameters:
  `symbolicName` - The bundle symbolic name or `null` for all required bundles.
Returns:
  An array of required bundles or `null` if no required bundles exist for the specified symbolic name.
Since:
  1.2

### getBundles

Bundle[] getBundles(String symbolicName, String versionRange)
Deprecated.
Returns the bundles with the specified symbolic name whose bundle version is within the specified version range. If no bundles are installed that have the specified symbolic name, then `null` is returned. If a version range is specified, then only the bundles that have the specified symbolic name and whose bundle versions belong to the specified version range are returned. The returned bundles are ordered by version in descending version order so that the first element of the array contains the bundle with the highest version.

Parameters:
  `symbolicName` - The symbolic name of the desired bundles.
  `versionRange` - The version range of the desired bundles, or `null` if all versions are desired.
Returns:
  An array of bundles with the specified name belonging to the specified version range ordered in descending version order, or `null` if no bundles are found.
Since:
  1.2
See Also:
  - `Constants.BUNDLE_VERSION_ATTRIBUTE`

### getFragments

Bundle[] getFragments(Bundle bundle)
Deprecated.
Returns an array of attached fragment bundles for the specified bundle. If the specified bundle is a fragment then `null` is returned. If no fragments are attached to the specified bundle then `null` is returned.

This method does not attempt to resolve the specified bundle. If the specified bundle is not resolved then `null` is returned.

Parameters:
  `bundle` - The bundle whose attached fragment bundles are to be returned.
Returns:
  An array of fragment bundles or `null` if the bundle does not have any attached fragment bundles or the bundle is not resolved.
Throws:
  `IllegalArgumentException` - If the specified `Bundle` was not created by the same framework instance that registered this `PackageAdmin` service.
Since:
  1.2

### getHosts

Bundle[] getHosts(Bundle bundle)
Deprecated.
Returns the host bundles to which the specified fragment bundle is attached.

Parameters:
  `bundle` - The fragment bundle whose host bundles are to be returned.
Returns:
  An array containing the host bundles to which the specified fragment is attached or `null` if the specified bundle is not a fragment or is not attached to any host bundles.
Throws:
  `IllegalArgumentException` - If the specified `Bundle` was not created by the same framework instance that registered this `PackageAdmin` service.
Since:
  1.2

### getBundle

Bundle getBundle(Class clazz)
Deprecated.
Returns the bundle from which the specified class is loaded. The class loader of the returned bundle must have been used to load the specified class. If the class was not loaded by a bundle class loader then `null` is returned.

Parameters:
  `clazz` - The class object from which to locate the bundle.
Returns:
  The bundle from which the specified class is loaded or `null` if the class was not loaded by a bundle class loader created by the same framework instance that registered this `PackageAdmin` service.
Since:
  1.2

### getBundleType

int getBundleType(Bundle bundle)
Deprecated.
Returns the special type of the specified bundle. The bundle type values are:

- `BUNDLE_TYPE_FRAGMENT`

A bundle may be more than one type at a time. A type code is used to identify the bundle type for future extendability.

If a bundle is not one or more of the defined types then 0x00000000 is returned.

Parameters:
  `bundle` - The bundle for which to return the special type.
Returns:
  The special type of the bundle.
Throws:
  `IllegalArgumentException` - If the specified `Bundle` was not created by the same framework instance that registered this `PackageAdmin` service.
Since:
  1.2